function varargout=sudokuSolver(varargin)
% global z z1
close all
sx=30; sy=30;
b1Pos=[9*sx+10 4*sy+15 30 30];
fPos3=b1Pos(1)+b1Pos(3)+9*sx+10;
fPos4=9*sy+50;
figCol=[1 1 1]*0.84;

f=figure(1);
set(f,'Position',[300 500 fPos3 fPos4],...
    'MenuBar','none',...
    'Name','Sudoku Solver',...
    'NumberTitle','off',...
    'Color',figCol);

txt1=uicontrol(f,'Style','text',...
    'FontName','Comic Sans MS',...
    'FontSize',12,...
    'String','INPUT',...
    'Position',[3*sx 9*sy+25 100 20],...
    'BackgroundColor',figCol);

txt2=uicontrol(f,'Style','text',...
    'FontName','Comic Sans MS',...
    'FontSize',12,...
    'String','OUTPUT',...
    'Position',[13*sx+10 9*sy+25 100 20],...
    'BackgroundColor',figCol);

ib=uicontrol(f,'Style','text',...
    'FontName','Comic Sans MS',...
    'FontSize',8,...
    'String',' Mohit Gupta',...
    'Position',[13*sx+10 0 200 15],...
    'BackgroundColor',figCol);

rc=0.15;
for i=1:9
    for j=1:9
        bgc=[1 1-rand(1)*rc 1-rand(1)*rc];
        e(i,j)=uicontrol(f,'Style','edit',...
            'Position', [(j-1)*sx+5 (9-i)*sy+15 sx sy],...
            'BackgroundColor',bgc,...
            'String','',...
            'FontName','Comic Sans MS',...
            'FontSize',12,...
            'Callback',{@edit_callback,i,j});
    end
end

b1=uicontrol(f,'Style','pushbutton',...
    'FontName','Comic Sans MS',...
    'FontSize',12,...
    'String','>>',...
    'Position',b1Pos,...
    'BackgroundColor',figCol,...
    'Callback', {@calc_callback});

b2=uicontrol(f,'Style','pushbutton',...
    'FontName','Comic Sans MS',...
    'FontSize',8,...
    'String','clear',...
    'Position',[b1Pos(1) b1Pos(2)-sx b1Pos(3:4)],...
    'BackgroundColor',figCol,...
    'Callback', {@clear_callback});

for i=1:9
    for j=1:9
        bgc=[1-rand(1)*rc 1 1-rand(1)*rc];
        g(i,j)=uicontrol(f,'Style','edit',...
            'FontName','Comic Sans MS',...
            'FontSize',12,...
            'Position', [b1Pos(1)+b1Pos(3)+(j-1)*sx+5 (9-i)*sy+15 sx sy],...
            'BackgroundColor',bgc,...
            'String','',...
            'Callback',{@edit_callback_g,i,j});
    end
end

% assignin('base','sudoku_input',z)
% assignin('base','sudoku_output',z1)

    function calc_callback(hObject, eventdata)
        global z z1
        for i=1:9
            for j=1:9
                ztmp=0;
                ztmp=str2double(get(e(i,j),'String'));
                if isempty(ztmp)
                    ztmp=0;
                elseif isnan(ztmp)
                    ztmp=0;
                else
                end
                z(i,j)=ztmp;
            end
        end
        assignin('base','sudoku_input',z)
        z1=sudoku(z);
        assignin('base','sudoku_output',z1)
        for i=1:9
            for j=1:9
                set(g(i,j),'String',num2str(z1(i,j)))
            end
        end
    end

    function edit_callback(hObject, eventdata,i,j)
        ztmp=str2double(get(e(i,j),'String'));
        if isempty(get(e(i,j),'String'))==0 % if cell is not empty
            % check for numeric input
            if isnan(ztmp)
                errordlg('Invalid input!!! Numeric input only!');
                set(e(i,j),'String','');
                set(g(i,j),'String','');
                return
            end
            % check for range of number
            if ztmp>9 || ztmp<0
                errordlg('Invalid input!!! Numberic values from 1 to 9 accepted');
                set(e(i,j),'String','');
                set(g(i,j),'String','');
                return
            end
            % check for decimal point
            if round(ztmp)~=ztmp
                errordlg('Invalid input!!! Only integer values accepted!');
                set(e(i,j),'String','');
                set(g(i,j),'String','');
                return
            end
            bgc=[0.75 0.75 1];
            %if ztmp>0
                set(e(i,j),'BackgroundColor',bgc)
                set(g(i,j),'String',num2str(ztmp))
                set(g(i,j),'BackgroundColor',bgc)
            %end
        else
            set(e(i,j),'BackgroundColor',[1 1-rand(1)*rc 1-rand(1)*rc])
            set(g(i,j),'String','')
            set(g(i,j),'BackgroundColor',[1-rand(1)*rc 1 1-rand(1)*rc])
        end
    end

    function edit_callback_g(hObject, eventdata,i,j)
        ztmp=get(g(i,j),'String');
        ztmp2=get(e(i,j),'String');
        set(g(i,j),'String',ztmp2);
    end

    function clear_callback(hObject, eventdata)
        for i=1:9
            for j=1:9
                set(g(i,j),'String','')
                set(g(i,j),'BackgroundColor',[1-rand(1)*rc 1 1-rand(1)*rc])
                set(e(i,j),'String','')
                set(e(i,j),'BackgroundColor',[1 1-rand(1)*rc 1-rand(1)*rc])
            end
        end
    end

end